Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 355276)
+++ channels/chan_sip.c	(working copy)
@@ -12609,6 +12609,8 @@
 		if ((state & AST_EXTENSION_RINGING) && sip_cfg.notifyringing) {
 			const char *local_display = exten;
 			char *local_target = ast_strdupa(mto);
+			const char *remote_display = exten;
+			char *remote_target = ast_strdupa(mfrom);
 
 			/* There are some limitations to how this works.  The primary one is that the
 			   callee must be dialing the same extension that is being monitored.  Simply dialing
@@ -12618,6 +12620,7 @@
 
 				if ((caller = ast_channel_callback(find_calling_channel, NULL, p, 0))) {
 					char *cid_num;
+					char *connected_num;
 					int need;
 
 					ast_channel_lock(caller);
@@ -12628,10 +12631,21 @@
 					snprintf(local_target, need, "sip:%s@%s", cid_num, p->fromdomain);
 					local_display = ast_strdupa(S_COR(caller->caller.id.name.valid,
 						caller->caller.id.name.str, ""));
+					connected_num = S_COR(caller->connected.id.number.valid,
+						caller->connected.id.number.str, "");
+					need = strlen(connected_num) + strlen(p->fromdomain) + sizeof("sip:@");
+					remote_target = alloca(need);
+					snprintf(remote_target, need, "sip:%s@%s", connected_num, p->fromdomain);
+
+					remote_display = ast_strdupa(S_COR(caller->connected.id.name.valid,
+						caller->connected.id.name.str, ""));
+
 					ast_channel_unlock(caller);
 					caller = ast_channel_unref(caller);
 				}
 
+				ast_log(LOG_NOTICE, "GOing to send this info: Local display = %s, Local target = %s, remote display = %s, remote target = %s\n", local_display, local_target, remote_display, remote_target);
+
 				/* We create a fake call-id which the phone will send back in an INVITE
 				   Replaces header which we can grab and do some magic with. */
 				if (sip_cfg.pedanticsipchecking) {
@@ -12649,10 +12663,10 @@
 						"<target uri=\"%s\"/>\n"
 						"</remote>\n"
 						"<local>\n"
-						"<identity>%s</identity>\n"
+						"<identity display=\"%s\">%s</identity>\n"
 						"<target uri=\"%s\"/>\n"
 						"</local>\n",
-						local_display, local_target, local_target, mto, mto);
+						remote_display, remote_target, remote_target, local_display, local_target, local_target);
 			} else {
 				ast_str_append(tmp, 0, "<dialog id=\"%s\" direction=\"recipient\">\n", exten);
 			}
